import ErrnoException = NodeJS.ErrnoException;
import * as http from 'http';

import * as dotenv from "dotenv"; // https://www.npmjs.com/package/dotenv

// Load data from '.env' file:
dotenv.config();
// console.info("'process.env.PORT': " + process.env.PORT);

import {app} from "./App.js";

const port = process.env.PORT || '1963';
app.set('port', port);
const server = http.createServer(app);
server.listen(port);
server.on('error', (error: ErrnoException) => {
    if (error.syscall !== 'listen') throw error;
    const bind = typeof port === 'string' ? 'Pipe ' + port : 'Port ' + port;
    // Handle specific 'listening' errors with messages:
    switch (error.code) {
        case 'EACCES':
            console.error(bind + ' requires elevated privileges');
            process.exit(1);
        case 'EADDRINUSE':
            console.error(bind + ' is already in use');
            process.exit(2);
        default:
            throw error;
    }
});
server.on('listening', () => {
    console.info('listening' + " -> " + JSON.stringify(server.address()));
});
